com.io7m.r2.filters

## Class R2ShaderFilterFogParameters.Builder

- java.lang.Object
- - com.io7m.r2.filters.R2ShaderFilterFogParameters.Builder

- Enclosing class:
    R2ShaderFilterFogParameters

      public static final class R2ShaderFilterFogParameters.Builder
      extends Object

  Builds instances of type `R2ShaderFilterFogParameters`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

  `Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `R2ShaderFilterFogParameters` | `build()` Builds a new `R2ShaderFilterFogParameters`.
    `R2ShaderFilterFogParameters.Builder` | `from(R2ShaderFilterFogParametersType instance)` Fill a builder with attribute values from the provided `R2ShaderFilterFogParametersType` instance.
    `R2ShaderFilterFogParameters.Builder` | `setFogColor(com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceRGBType> fogColor)` Initializes the value for the `fogColor` attribute.
    `R2ShaderFilterFogParameters.Builder` | `setFogFarPositiveZ(float fogFarPositiveZ)` Initializes the value for the `fogFarPositiveZ` attribute.
    `R2ShaderFilterFogParameters.Builder` | `setFogNearPositiveZ(float fogNearPositiveZ)` Initializes the value for the `fogNearPositiveZ` attribute.
    `R2ShaderFilterFogParameters.Builder` | `setImageDepthTexture(R2Texture2DUsableType imageDepthTexture)` Initializes the value for the `imageDepthTexture` attribute.
    `R2ShaderFilterFogParameters.Builder` | `setImageTexture(R2Texture2DUsableType imageTexture)` Initializes the value for the `imageTexture` attribute.
    `R2ShaderFilterFogParameters.Builder` | `setObserverValues(R2MatricesObserverValuesType observerValues)` Initializes the value for the `observerValues` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### from

          public final R2ShaderFilterFogParameters.Builder from(R2ShaderFilterFogParametersType instance)

      Fill a builder with attribute values from the provided `R2ShaderFilterFogParametersType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
      Parameters:
        `instance` - The instance from which to copy values
      Returns:
        `this` builder for use in a chained invocation

    - #### setImageTexture

          public final R2ShaderFilterFogParameters.Builder setImageTexture(R2Texture2DUsableType imageTexture)

      Initializes the value for the `imageTexture` attribute.
      Parameters:
        `imageTexture` - The value for imageTexture
      Returns:
        `this` builder for use in a chained invocation

    - #### setImageDepthTexture

          public final R2ShaderFilterFogParameters.Builder setImageDepthTexture(R2Texture2DUsableType imageDepthTexture)

      Initializes the value for the `imageDepthTexture` attribute.
      Parameters:
        `imageDepthTexture` - The value for imageDepthTexture
      Returns:
        `this` builder for use in a chained invocation

    - #### setFogNearPositiveZ

          public final R2ShaderFilterFogParameters.Builder setFogNearPositiveZ(float fogNearPositiveZ)

      Initializes the value for the `fogNearPositiveZ` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `fogNearPositiveZ`.

      Parameters:
        `fogNearPositiveZ` - The value for fogNearPositiveZ
      Returns:
        `this` builder for use in a chained invocation

    - #### setFogFarPositiveZ

          public final R2ShaderFilterFogParameters.Builder setFogFarPositiveZ(float fogFarPositiveZ)

      Initializes the value for the `fogFarPositiveZ` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `fogFarPositiveZ`.

      Parameters:
        `fogFarPositiveZ` - The value for fogFarPositiveZ
      Returns:
        `this` builder for use in a chained invocation

    - #### setFogColor

          public final R2ShaderFilterFogParameters.Builder setFogColor(com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceRGBType> fogColor)

      Initializes the value for the `fogColor` attribute.
      Parameters:
        `fogColor` - The value for fogColor
      Returns:
        `this` builder for use in a chained invocation

    - #### setObserverValues

          public final R2ShaderFilterFogParameters.Builder setObserverValues(R2MatricesObserverValuesType observerValues)

      Initializes the value for the `observerValues` attribute.
      Parameters:
        `observerValues` - The value for observerValues
      Returns:
        `this` builder for use in a chained invocation

    - #### build

          public R2ShaderFilterFogParameters build()

      Builds a new `R2ShaderFilterFogParameters`.
      Returns:
        An immutable instance of R2ShaderFilterFogParameters
      Throws:
        `IllegalStateException` - if any required attributes are missing

Copyright © 2017 <code@io7m.com> http://io7m.com